/** 
 * @file network.c
 * @brief IPʐM(\[X)
 * @author 
 * @date 2016-04-15
 * @version 1.00
 *
 * Copyright (C) 2016 - TPIP User Community All rights reserved.
 * ̃t@C̒쌠́ATPIP[U[R~jeB̋Kɏ]gp܂B
 */

#include "network.h"

int udp_open_server(unsigned short ServPort)
{

#ifdef WIN32
	WSADATA data;
#endif

	int sock;
	struct sockaddr_in ServAddr;

#ifdef WIN32
	if(WSAStartup(0x0101, &data) != 0){
		//printf("NG:WSAStartup()\n");
		return -1;
	}
#endif

	if((sock = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP))<0){
		//printf("NG:socket()\n");
		return -1;
	}

	memset(&ServAddr, 0, sizeof(ServAddr));
	ServAddr.sin_family = AF_INET;
	ServAddr.sin_addr.s_addr = htonl(INADDR_ANY);
	ServAddr.sin_port = htons(ServPort);

	if(bind(sock,(struct sockaddr *)&ServAddr,sizeof(ServAddr))<0){
		//printf("NG:bind()\n");
		return -1;
	}

	return sock;
}

int udp_open_client(struct sockaddr_in *ServAddr,char *ServIP,unsigned short ServPort)
{

#ifdef WIN32
	WSADATA data;
#endif

	int sock;

#ifdef WIN32
	if(WSAStartup(0x0101, &data) != 0){
		//printf("NG:WSAStartup()\n");
		return -1;
	}
#endif

	if((sock = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP))<0){
		//printf("ERROR: socket()\n");
		return -1;
	}

	ServAddr->sin_family = AF_INET;
	ServAddr->sin_addr.s_addr = inet_addr(ServIP);
	ServAddr->sin_port = htons(ServPort);

	return sock;
}

int udp_close(int sock)
{
#ifdef WIN32
	closesocket(sock);
	WSACleanup();
#endif

#ifndef WIN32
	close(sock);
#endif

	return 0;
}

int udp_send(int sock,char *buf,int size,struct sockaddr_in *ToAddr)
{
	int num;

	if((num=sendto(sock,buf,size,0,(struct sockaddr *)ToAddr,sizeof(*ToAddr)))==-1){
		//printf("NG:sendto()\n");
		return -1;
	}

	return num;
}

int udp_recv(int sock,char *buf,int size,struct sockaddr_in *FromAddr)
{

	int FromSize,num;

	FromSize=sizeof(*FromAddr);	
	if((num=recvfrom(sock,buf,size,0,(struct sockaddr*)FromAddr,(unsigned int*)&FromSize))==-1){
		//printf("NG:recvfrom()\n");
		return -1;
	}

	return num;
}

int tcp_open_server(unsigned short ServPort)
{

#ifdef WIN32
	WSADATA data;
#endif

	int sock;
	struct sockaddr_in ServAddr;

#ifdef WIN32
	if(WSAStartup(0x0101, &data) != 0){
		//printf("NG:WSAStartup()\n");
		return -1;
	}
#endif

	if((sock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP))<0){
		//printf("NG:socket()\n");
		return -1;
	}

	memset(&ServAddr, 0, sizeof(ServAddr));
	ServAddr.sin_family = AF_INET;
	ServAddr.sin_addr.s_addr = htonl(INADDR_ANY);
	ServAddr.sin_port = htons(ServPort);

	if(bind(sock,(struct sockaddr *)&ServAddr,sizeof(ServAddr))<0){
		//printf("NG:bind()\n");
		return -1;
	}

	if(listen(sock,5)<0){
		//printf("NG:listen()\n");
		return -1;
	}

	return sock;
}

int tcp_open_client(char *ServIP,unsigned short ServPort)
{

	struct sockaddr_in ServAddr;

#ifdef WIN32
	WSADATA data;
#endif

	int sock;

#ifdef WIN32
	if(WSAStartup(0x0101, &data) != 0){
		//printf("NG:WSAStartup()\n");
		return -1;
	}
#endif

	if((sock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP))<0){
		//printf("ERROR: socket()\n");
		return -1;
	}

	memset(&ServAddr,0,sizeof(ServAddr));
	ServAddr.sin_family = AF_INET;
	ServAddr.sin_addr.s_addr = inet_addr(ServIP);
	ServAddr.sin_port = htons(ServPort);

	if(connect(sock,(struct sockaddr*)&ServAddr,sizeof(ServAddr))<0){
		//printf("ERROR: connect()\n");
		return -1;
	}

	return sock;
}

int tcp_accept( int srcSock )
{
	int dstSock;
	struct sockaddr_in dstAddr;
	unsigned int dstAddrSize = sizeof(dstAddr);

	//printf("Waiting for connection ...\n");
	if((dstSock = accept(srcSock, (struct sockaddr *) &dstAddr, &dstAddrSize)) == -1)
	{
		//printf("ERROR: accept\n");
		return -1;
	}
	//printf("OK: accept\n");
	//printf("Connected from %s\n", inet_ntoa(dstAddr.sin_addr));

	return dstSock;
}

int tcp_send(int sock,char *buf,int size)
{
	int num;

	if((num=send(sock,buf,size,0))==-1){
		//printf("NG:send()\n");
		return -1;
	}

	return num;
}

int tcp_recv(int sock,char *buf,int size)
{

	int num;

	if((num=recv(sock,buf,size,0))==-1){
		//printf("NG:recv()\n");
		return -1;
	}

	return num;
}

int tcp_close(int sock)
{
#ifdef WIN32
	closesocket(sock);
	WSACleanup();
#endif

#ifndef WIN32
	close(sock);
#endif

	return 0;
}


